"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var fs = __importStar(require("fs"));
var commandpost = __importStar(require("commandpost"));
var YAML = __importStar(require("js-yaml"));
var converter_1 = require("./converter");
var pkg = require("../package.json");
var root = commandpost
    .create("sw2dts [input_filename]")
    .version(pkg.version, "-v, --version")
    .option("-w, --with-query", "With GET query parameters.")
    .option("-s, --sort-props", "Sort type properties order.")
    .option("-o, --output <output_filename>", "Output to file.")
    .option("-n, --namespace <namespace>", "Use namespace.")
    .option("--stdin", "[Deprecated] Input from standard input.")
    .action(function (opts, args) { return __awaiter(_this, void 0, void 0, function () {
    var outputFilename, namespace, withQuery, sortProps, input, model;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                // TODO Delete '--stdin' option.
                if (opts.stdin) {
                    console.warn("'--stdin' option is deprecated.");
                }
                if (args.input_filename && opts.stdin) {
                    process.stderr.write("Invalid parameters!\n");
                    process.exit(1);
                    return [2 /*return*/];
                }
                outputFilename = opts.output[0];
                namespace = opts.namespace[0];
                withQuery = opts.withQuery;
                sortProps = opts.sortProps;
                return [4 /*yield*/, (args.input_filename ? fromFile(args.input_filename) : fromStdin())];
            case 1:
                input = _a.sent();
                return [4 /*yield*/, converter_1.convert(YAML.safeLoad(input), { namespace: namespace, withQuery: withQuery, sortProps: sortProps })];
            case 2:
                model = _a.sent();
                if (outputFilename) {
                    fs.writeFileSync(outputFilename, model);
                }
                else {
                    process.stdout.write(model);
                }
                process.exit(0);
                return [2 /*return*/];
        }
    });
}); });
commandpost
    .exec(root, process.argv)
    .catch(errorHandler);
function fromStdin() {
    process.stdin.setEncoding("utf-8");
    return new Promise(function (resolve, reject) {
        var data = "";
        process.stdin
            .on("data", function (chunk) { return data += chunk; })
            .once("end", function () { return resolve(data); })
            .once("error", function (err) { return reject(err); });
        setTimeout(function () {
            if (data) {
                return;
            }
            reject();
        }, 1000);
    });
}
function fromFile(inputFileName) {
    return new Promise(function (resolve, reject) {
        resolve(fs.readFileSync(inputFileName, { encoding: "utf-8" }));
    });
}
function errorHandler(err) {
    if (err == null) {
        process.stdout.write(root.helpText());
        process.exit(0);
        return;
    }
    if (err instanceof Error) {
        console.error(err.stack);
    }
    else if (err) {
        console.error(err);
    }
    process.exit(1);
}
