"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var dtsgenerator_1 = __importDefault(require("dtsgenerator"));
function convert(data, options) {
    if (options === void 0) { options = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var namespace, jsonSchemas, title, schema, _loop_1, path, text;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!options.nameResolver) {
                        options.nameResolver = PascalCaseNameResolver;
                    }
                    namespace = (options.namespace || "");
                    jsonSchemas = [];
                    for (title in data.definitions) {
                        schema = data.definitions[title];
                        fixRef(schema);
                        schema.id = title;
                        jsonSchemas.push(schema);
                    }
                    if (options.withQuery) {
                        _loop_1 = function (path) {
                            var props = data.paths[path];
                            if (!props.get || isEmpty(props.get.parameters)
                                || props.get.parameters.some(function (v) { return v.in !== "query"; })) {
                                return "continue";
                            }
                            var required = [];
                            var properties = props.get.parameters.reduce(function (result, value) {
                                result[value.name] = {
                                    type: value.type,
                                    items: value.items,
                                    enum: value.enum,
                                };
                                if (value.required) {
                                    required.push(value.name);
                                }
                                return result;
                            }, {});
                            var schema = {
                                id: options.nameResolver(path, props, options),
                                type: "object",
                                properties: properties,
                                required: required,
                            };
                            jsonSchemas.push(schema);
                        };
                        for (path in (data.paths || [])) {
                            _loop_1(path);
                        }
                    }
                    if (options.sortProps) {
                        jsonSchemas.filter(function (sd) { return !!sd.properties; }).forEach(function (sd) {
                            sd.properties = Object.keys(sd.properties).sort().reduce(function (result, key) {
                                result[key] = sd.properties[key];
                                return result;
                            }, {});
                        });
                    }
                    return [4 /*yield*/, dtsgenerator_1.default({ contents: jsonSchemas })];
                case 1:
                    text = _a.sent();
                    if (!namespace) {
                        return [2 /*return*/, text];
                    }
                    text = text.split("\n").join("\n    ").trim();
                    return [2 /*return*/, "declare namespace " + namespace + " {\n    " + text + "\n}\n"];
            }
        });
    });
}
exports.convert = convert;
function fixRef(obj) {
    for (var key in obj) {
        if (key === "$ref") {
            obj["$ref"] = obj["$ref"].split("/").pop();
        }
        else if (typeof obj[key] === "object") {
            fixRef(obj[key]);
        }
    }
}
function isEmpty(array) {
    return array ? !array.length : true;
}
/**
 * Default name resolver which resolve name as PascalCase from path string.
 */
function PascalCaseNameResolver(path, pathDefinition, options) {
    options = options || {};
    path = path.replace(/{[^}]*}/g, '').replace(/\/$/, '');
    path = path.replace(/(^|[\/_-])(\w)/g, function (substr) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return args[1].toUpperCase();
    });
    path = path.replace(/(\d+)(\w)/, function (substr) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return args[0] + args[1].toUpperCase();
    });
    return path;
}
exports.PascalCaseNameResolver = PascalCaseNameResolver;
